#ifndef _fencer_collision_h
#define _fencer_collision_h

#include "shape.h"
#include "physics_entity.h"
#include <stddef.h>

typedef struct Collision {
    PhysicsEntity other;

    Vector point;
    Vector normal;

    Vector velocity;
    Vector penetration_vector;

    Vector edge_left;
    Vector edge_right;
} Collision;

extern Collision collision_invert(Collision src, PhysicsEntity new_other);
extern int collision_check(PhysicsEntity a, PhysicsEntity b, Collision* out_a, Collision* out_b);

#endif // !_fencer_collision_h
